
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <sys/time.h>
#include <netdb.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/fcntl.h>
#include <errno.h>
#include <signal.h>

#define MAX_COMMAND_LEN		1024
#define EXIT_COMMAND		0
#define EXECV_COMMAND		1
#define EXECVP_COMMAND		2

char *STRALLOC( char * str )
{
	char *tmp;
	tmp = malloc( strlen(str)+1);
	strcpy( tmp, str );
	return(tmp);
}




tcp_open(int port )
{
  struct hostent *hostent;
  struct sockaddr_in sockaddr;
  int tmp;
  static  char hostname[100];
  struct protoent *protoent;
  int fd;
  int Len, i, j;
  char *TclCmd;

  gethostname( hostname, 98 );

  hostent = gethostbyname (hostname);

  if (!hostent)
    {
      fprintf(stderr, "%s: unknown host\n", hostname);
      errno = ENOENT;
      return -1;
    }

  fd = socket (AF_INET, SOCK_STREAM, 0);
  if (fd < 0)
    return -1;

  /* Allow rapid reuse of this port. */
  tmp = 1;
  setsockopt (fd, SOL_SOCKET, SO_REUSEADDR, (char *)&tmp, sizeof(tmp));

  /* Enable TCP keep alive process. */
  tmp = 1;
  setsockopt (fd, SOL_SOCKET, SO_KEEPALIVE, (char *)&tmp, sizeof(tmp));

  sockaddr.sin_family = AF_INET;
  sockaddr.sin_port = htons(port);
  memcpy (&sockaddr.sin_addr.s_addr, hostent->h_addr,
          sizeof (struct in_addr));

  if (connect (fd, &sockaddr, sizeof(sockaddr)))
    {
      close(fd);
      fd = -1;
      return -1;
    }
  return fd;
}


main( int argc, char **argv )
{
	int exec_sock = -1;
	int i;
	static char ExecBuf[MAX_COMMAND_LEN];
	int Command;
	char *path, **arglist, **env;
	int num_args, nenv, ioport;
	char *cp;
	char buf[32];
	int pid;
	unsigned char len;

	if ( argc < 2 ) {
		fprintf( stderr, "Usage: execd <portnumber>\n" );
		exit(-1);
	}
	exec_sock = tcp_open( atoi(argv[1] ));
	if ( exec_sock < 0 ) {
		fprintf( stderr, "execd: Could not connect to port %d\n", atoi(argv[1] ));
		exit(-1);
	}
	while (1) {
		if ( read( exec_sock, &len, 1 ) <= 0 ){
			close(exec_sock);
			exit(-1);
		}
		if ( read( exec_sock, ExecBuf, len ) <= 0 ){
			close(exec_sock);
			exit(-1);
		}
		Command = ExecBuf[0];
		if ( ExecBuf[0] == EXIT_COMMAND ){
			close(exec_sock);
			exit(0);
		}
		if (( ExecBuf[0] != EXECV_COMMAND )&&( ExecBuf[0] != EXECVP_COMMAND )){
			fprintf( stderr, "execd: Unknown command %d\n", ExecBuf[0] );
			close(exec_sock);
			exit(-1);
		} 
		num_args = ExecBuf[1];
		nenv = ExecBuf[2];
		cp = (unsigned char *)&ioport+sizeof(long)-1;
		for ( i = 0; i < 4; i++ ){
			*cp-- = ExecBuf[3+i];
		}
		path = STRALLOC( &(ExecBuf[7]));
		arglist = (char **)malloc(( num_args+1)*sizeof(char *));
		env = (char **)malloc(( nenv+1)*sizeof(char *));
		for ( i = 0; i < num_args; i++ ){
			if ( read( exec_sock, &len, 1 ) < 0 ){
				close(exec_sock);
				exit(-1);
			}
			if ( read( exec_sock, ExecBuf, len ) < 0 ){
				close(exec_sock);
				exit(-1);
			}
			arglist[i] = STRALLOC(ExecBuf);
		}
		arglist[i] = NULL;
		for ( i = 0; i < nenv; i++ ){
			if ( read( exec_sock, &len, 1 ) < 0 ){
				close(exec_sock);
				exit(-1);
			}
			if ( read( exec_sock, ExecBuf, len ) < 0 ){
				close(exec_sock);
				exit(-1);
			}
			env[i] = STRALLOC(ExecBuf);
		}
		if ( Command == EXECV_COMMAND ){
			if (!(pid = fork())){
				int out;
				out = tcp_open( ioport );
				for ( i = 0; i < nenv; i++ ){
					putenv( env[i] );
				}
				sprintf(buf, "PVMEPID=%d", getpid());
				putenv( buf );
                                dup2(out, 1);
                                dup2(1, 2);
                                for (i = getdtablesize(); --i > 2; )
                                        (void)close(i);
				execv( path, arglist );
				exit(1);
			} else {
				cp = (unsigned char *)&pid+sizeof(long)-1;
				for ( i = 0; i < 4; i++ ){
					ExecBuf[i] = *cp--;
				}
				write( exec_sock, ExecBuf, 4 );
			}
		}
	}
}

