#
# $Id: xpvm.tcl,v 2.310 1994/07/18 18:18:46 kohl Exp $
#

#
# Hide Main Window
#

wm withdraw .

#
# Source TCL Procs
#

set xpvm_directory /home/users_5/rs1/pvm3/xpvm

set help_dir $xpvm_directory/src/help

set ckdir_procs [ file exists procs.tcl ]

if { $ckdir_procs == 1 } \
	{ source procs.tcl } \
else \
	{ source $xpvm_directory/procs.tcl }

set ckdir_util [ file exists util.tcl ]

if { $ckdir_util == 1 } \
	{ source util.tcl } \
else \
	{ source $xpvm_directory/util.tcl }

#
# Proc Debug Flag
#

set proc_debug FALSE

#
# Get User Name
#

set user [ get_user_name ]

#
# Set up Spacing Constants
#

set main_height 850
set main_width 700

set row_height 20
set col_width 12

set scroll_width 20

set border_space 10

set frame_border 2

#
# General View Constants / Globals
#

set scroll_canvas_width 4000

set scale_stack [ list empty ]

set scale 20000

set timeid_prim ""

set timeidx -1

set timex 0

#
# Help Window Constants
#

set min_help_height [ expr (2 * $row_height) + (3 * $scroll_width) \
	+ (2 * $border_space) ]

set min_help_width 250

set help_stagger_index 0

#
# Network View Constants
#

set net_active TRUE

set net_scroll 16

set net_size 2000

set icon_border 2

set icon_space 10

set net_space 32

set min_net_height [ expr (2 * $row_height) + (3 * $scroll_width) \
	+ (2 * $border_space) ]

#
# View Select & Playback Controls Constants
#

set ctrl_height [ expr (2 * $row_height) + (3 * $border_space) ]

#
# Space-Time View Constants
#

set st_labels_width [ expr 15 * $col_width ]

set st_canvas_height 4000

set st_scroll_mark 0

set st_active TRUE

set st_highlight_type ""

set st_highlight_id -1

set st_label_ht $row_height

set st_rect_ht 8

set st_timeid -1

set st_usec 0
set st_sec 0

set min_st_height [ expr (2 * $row_height) + (3 * $scroll_width) \
	+ (3 * $border_space) ]

#
# Utilization View Constants
#

set ut_canvas_height 4000

set ut_scroll_mark 0

set ut_max_ntasks 1

set ut_active FALSE

set ut_state [ list none ]

set ut_timeid -1

set ut_height 350
set ut_width 700

set ut_running 0
set ut_system 0
set ut_idle 0

#
# Call Trace View Constants
#

set ct_labels_width [ expr 15 * $col_width ]

set ct_canvas_height 4000
set ct_canvas_width 2000

set ct_query_index -1

set ct_height 340
set ct_width 650

set ct_active FALSE

#
# Task Output View Constants
#

set to_canvas_height 8000
set to_canvas_width 2000

set to_height 300
set to_width 600

set to_active FALSE

#
# Global Variables
#

set ncomm 0

set ntask 0

set nhost 0

#
# Create Toplevel Window
#

set main_geom "[ expr $main_width ]x[ expr $main_height ]+10+10"

toplevel .xpvm

wm geometry .xpvm $main_geom

wm withdraw .xpvm

set min_main_height [ expr (3 * $row_height) + (3 * $border_space) \
	+ $min_net_height + $ctrl_height + $min_st_height ]

set min_main_width 400

wm minsize .xpvm $min_main_width $min_main_height

set depth [ winfo depth .xpvm ]

#
# Set up Colors
#

if { $depth == 1 } \
{
	set active_fg_color white

	set selector_color black

	set fg_color black

	set net_running_color black
	set net_system_color white
	set net_idle_color white
	set net_empty_color white
	set net_fg_color black

	set st_running_color black
	set st_system_color white
	set st_idle_color white
	set st_comm_color black

	set ut_running_color black
	set ut_system_color white
	set ut_idle_color black
} \
else \
{
	set active_fg_color purple

	set selector_color purple

	set fg_color blue

	set net_running_color green
	set net_system_color yellow
	set net_idle_color yellow
	set net_empty_color white
	set net_fg_color black

	set st_running_color green
	set st_system_color yellow
	set st_idle_color white
	set st_comm_color red

	set ut_running_color green
	set ut_system_color yellow
	set ut_idle_color red
}

#
# Define PVM Architectures
#

set xbm_dir "$xpvm_directory/src/xbm"

define_arch AFX8		"$xbm_dir/alliant.xbm"
define_arch ALPHA		"$xbm_dir/alpha.xbm"
define_arch BAL			"$xbm_dir/sequent.xbm"
define_arch CM2			"$xbm_dir/cm2.xbm"
define_arch CM5			"$xbm_dir/cm5.xbm"
define_arch CRAY		"$xbm_dir/cray.xbm"
define_arch CRAYSMP		"$xbm_dir/cray.xbm"
define_arch HPPA		"$xbm_dir/hppa.xbm"
define_arch I860		"$xbm_dir/i860.xbm"
define_arch IPSC2		"$xbm_dir/ipsc2.xbm"
define_arch KSR1		"$xbm_dir/ksr1.xbm"
define_arch PGON		"$xbm_dir/pgon.xbm"
define_arch PMAX		"$xbm_dir/pmax.xbm"
define_arch RS6K		"$xbm_dir/rs6k.xbm"
define_arch RT			"$xbm_dir/rs6k.xbm"
define_arch SGI			"$xbm_dir/sgi.xbm"
define_arch SGI5		"$xbm_dir/sgi5.xbm"
define_arch SUN3		"$xbm_dir/sun3.xbm"
define_arch SUN4		"$xbm_dir/sparc.xbm"
define_arch SUN4SOL2	"$xbm_dir/sun4sol2.xbm"
define_arch SUNMP		"$xbm_dir/sunmp.xbm"
define_arch SYMM		"$xbm_dir/symmetry.xbm"
define_arch T9000		"$xbm_dir/t9000.xbm"

# define_arch BFLY
# define_arch BSD386
# define_arch CNVX
# define_arch CNVXN
# define_arch DGAV
# define_arch HP300
# define_arch NEXT
# define_arch TITN
# define_arch UVAX

define_arch DUMMY	"$xbm_dir/dummy_arch.xbm"

#
# Load Bitmaps
#

load_bitmap_file "$xbm_dir/rewind.xbm"
load_bitmap_file "$xbm_dir/stop.xbm"
load_bitmap_file "$xbm_dir/fwd.xbm"
load_bitmap_file "$xbm_dir/fwdstep.xbm"

load_bitmap_file "$xbm_dir/shrink.xbm"
load_bitmap_file "$xbm_dir/grow.xbm"
load_bitmap_file "$xbm_dir/adj.xbm"

#
# Create Title & Version Number
#

set title_str "X P V M  [ title_info ]"

label .xpvm.title -text $title_str -foreground $fg_color

#
# Create Info Message Label
#

label .xpvm.message -text "Status:   Welcome to XPVM" \
	-foreground $fg_color -relief sunken -anchor nw

#
# Place Title & Message
#

place .xpvm.title -relx 0.5 -y $border_space -anchor n

set msg_y [ expr $row_height + (3 * $border_space / 2) ]

set msg_wt [ expr $main_width - (2 * $border_space) ]

place .xpvm.message -x $border_space -y $msg_y -width $msg_wt

update

#
# Get Main Font for Entry Widgets
#

set main_font [ lindex [ .xpvm.title configure -font ] 3 ]

#
# Set Up Submenu Dependencies
#

set hosts_subs "{ .xpvm.other }"

set tm_subs "{ .xpvm.host_ev_menu .xpvm.group_ev_menu \
	.xpvm.task_ev_menu .xpvm.comm_ev_menu .xpvm.coll_ev_menu \
	.xpvm.buff_ev_menu .xpvm.pack_ev_menu .xpvm.unpack_ev_menu \
	.xpvm.info_ev_menu .xpvm.misc_ev_menu }"

set spawn_subs "{ [ concat [ expr $tm_subs ] .xpvm.trace_mask_menu ] }"

set tasks_subs "{ [ concat [ expr $spawn_subs ] .xpvm.spawn \
	.xpvm.kill .xpvm.signal .xpvm.systasks_menu ] }"

#
# Create Console Buttons
#

button .xpvm.hosts	-text "Hosts..." \
	-foreground $fg_color -activeforeground $active_fg_color \
	-command "raiseMenu .xpvm.hosts_menu .xpvm.hosts .xpvm $hosts_subs"

button .xpvm.tasks	-text "Tasks..." \
	-foreground $fg_color -activeforeground $active_fg_color \
	-command "raiseMenu .xpvm.tasks_menu .xpvm.tasks .xpvm $tasks_subs"

button .xpvm.reset -text "Reset..." \
	-foreground $fg_color -activeforeground $active_fg_color \
	-command "raiseMenu .xpvm.reset_menu .xpvm.reset .xpvm {}"

button .xpvm.quit -text "Quit" -command pvm_quit \
	-foreground $fg_color -activeforeground $active_fg_color

button .xpvm.halt -text "Halt" -command pvm_halt \
	-foreground $fg_color -activeforeground $active_fg_color

set help_subs "{ .xpvm.tasks_help_menu .xpvm.views_help_menu }"

button .xpvm.help -text "Help..." \
	-foreground $fg_color -activeforeground $active_fg_color \
	-command "raiseMenu .xpvm.help_menu .xpvm.help .xpvm $help_subs"

#
# Place Console Command Buttons
#

set cons_y [ expr $msg_y + $row_height + $border_space ]

place .xpvm.hosts	-relx 0.10 -y $cons_y
place .xpvm.tasks	-relx 0.25 -y $cons_y
place .xpvm.reset	-relx 0.40 -y $cons_y
place .xpvm.quit	-relx 0.55 -y $cons_y
place .xpvm.halt	-relx 0.70 -y $cons_y
place .xpvm.help	-relx 0.85 -y $cons_y

#
# Set Up Division of Main Panel
#

set start_main_y [ expr $cons_y + $row_height + ($border_space / 2) ]

set ctrl_width $main_width

set height_left [ expr $main_height - $start_main_y - $ctrl_height ]

set net_height [ expr $height_left / 2 ]
set net_width $main_width

set st_height [ expr $height_left - $net_height ]
set st_width $main_width

set net_x 0
set net_y $start_main_y

set ctrl_x 0
set ctrl_y [ expr $net_y + $net_height ]

set st_x 0
set st_y [ expr $ctrl_y + $ctrl_height ]

#
# Create Network Canvas
#

set NET_C .xpvm.network.canvas

set NET_SBH .xpvm.network.horiz_sb
set NET_SBV .xpvm.network.vert_sb

set net_cheight [ expr $net_height - $scroll_width \
	- (2 * $row_height) - (2 * $border_space) ]

set net_cwidth [ expr $net_width - $scroll_width - (2 * $border_space)]

frame .xpvm.network

label .xpvm.network.title -text "Network View" -foreground $fg_color

set pcoord [ expr $net_size / 2 ]

set ncoord [ expr -1 * ( $net_size / 2 ) ]

canvas $NET_C -bd $frame_border -relief sunken \
	-scrollincrement $net_scroll -confine 0 \
	-scrollregion "$ncoord $ncoord $pcoord $pcoord"

set bg_color [ $NET_C config -background ]

set cmd "scrollCanvas $NET_C $NET_SBH \
	net_size net_cwidth net_xview HORIZ $net_scroll"

scrollbar $NET_SBH -orient horiz -bd $frame_border -relief sunken \
	-width $scroll_width -command $cmd

scrollInit $NET_C $NET_SBH $net_size $net_cwidth net_xview \
	HORIZ center $net_scroll

set cmd "scrollCanvas $NET_C $NET_SBV \
	net_size net_cheight net_yview VERT $net_scroll"

scrollbar $NET_SBV -orient vert -bd $frame_border -relief sunken \
	-width $scroll_width -command $cmd

scrollInit $NET_C $NET_SBV $net_size $net_cheight net_yview \
	VERT center $net_scroll

set netline -1

set cmd "viewSelect network Network views_menu_state_Network TRUE"

button .xpvm.network.close -text "Close" -command $cmd \
	-foreground $fg_color -activeforeground $active_fg_color

#
# Create Network Key
#

label .xpvm.network.active_label -text "Active" \
	-foreground $fg_color

label .xpvm.network.active_box -text "    " \
	-bd 1 -relief sunken -background $net_running_color

label .xpvm.network.system_label -text "System" \
	-foreground $fg_color

label .xpvm.network.system_box -text "    " \
	-bd 1 -relief sunken -background $net_system_color

label .xpvm.network.empty_label -text "No Tasks" \
	-foreground $fg_color

label .xpvm.network.empty_box -text "    " \
	-bd 1 -relief sunken -background $net_empty_color

layout_net_panel

#
# Create View Select & Playback Controls
#

set CTRL .xpvm.controls

frame $CTRL -bd $frame_border -relief sunken

button $CTRL.adjust -bitmap "@$xbm_dir/adj.xbm" \
	-foreground $fg_color -activeforeground $active_fg_color

set rcmd "raiseMenu .xpvm.views_menu $CTRL.view_select .xpvm {}"

button $CTRL.view_select -text "Views" -command $rcmd \
	-foreground $fg_color -activeforeground $active_fg_color

button $CTRL.rewind -bitmap "@$xbm_dir/rewind.xbm" \
	-command trace_rewind \
	-foreground $fg_color -activeforeground $active_fg_color

button $CTRL.stop -bitmap "@$xbm_dir/stop.xbm" -command trace_stop \
	-foreground $fg_color -activeforeground $active_fg_color

button $CTRL.fwdstep -bitmap "@$xbm_dir/fwdstep.xbm" \
	-command trace_fwdstep \
	-foreground $fg_color -activeforeground $active_fg_color

button $CTRL.fwd -bitmap "@$xbm_dir/fwd.xbm" -command trace_fwd \
	-foreground $fg_color -activeforeground $active_fg_color

set trace_control_status "none"

label $CTRL.time -text "Time: 0.000000" -foreground $fg_color

label $CTRL.file -text "Trace File:" -foreground $fg_color

entry $CTRL.file_entry -font $main_font \
	-bd $frame_border -relief sunken -foreground $fg_color

bind $CTRL.file_entry <Enter> "focus $CTRL.file_entry"
bind $CTRL.file_entry <Leave> "set_trace_file"
bind $CTRL.file_entry <Return> "set_trace_file"

set tfck [ info exists trace_file ]

if { $tfck == 0 } { set trace_file "/tmp/xpvm.trace.$user" }

$CTRL.file_entry insert 0 $trace_file

radiobutton $CTRL.overwrite -text "OverWrite " \
	-command "handleTraceFileStatus" \
	-bd $frame_border -relief sunken -value "OverWrite" \
	-variable trace_file_status \
	-selector $selector_color -foreground $fg_color \
	-activeforeground $active_fg_color

radiobutton $CTRL.playback -text "PlayBack " \
	-command "handleTraceFileStatus" \
	-bd $frame_border -relief sunken -value "PlayBack" \
	-variable trace_file_status \
	-selector $selector_color -foreground $fg_color \
	-activeforeground $active_fg_color

set trace_file_status "OverWrite"

#
# Place View Select & Playback Controls
#

place $CTRL -x $ctrl_x -y $ctrl_y \
	-width $ctrl_width -height $ctrl_height

set butt_y [ expr $border_space / 2 ]

place $CTRL.adjust		-relx 0.02 -y $butt_y

place $CTRL.view_select	-relx 0.15 -y $butt_y

place $CTRL.rewind		-relx 0.35 -y $butt_y
place $CTRL.stop		-relx 0.43 -y $butt_y
place $CTRL.fwdstep		-relx 0.51 -y $butt_y
place $CTRL.fwd			-relx 0.59 -y $butt_y

place $CTRL.time -anchor ne -relx 0.995 -y $butt_y

update

set x [ expr $ctrl_width - $border_space ]

set y [ expr [ below $CTRL.view_select ] + $border_space ]

place $CTRL.overwrite -x $x -y $y -anchor ne

update

set x [ expr [ left $CTRL.overwrite ] - $border_space ]

place $CTRL.playback -x $x -y $y -anchor ne

update

set x [ expr $border_space / 2 ]

place $CTRL.file -x $x -y $y

update

set wt [ expr [ left $CTRL.playback ] - $x \
	- [ winfo width $CTRL.file ] - $border_space ]

set ht [ winfo height $CTRL.overwrite ]

place $CTRL.file_entry -x [ right $CTRL.file ] -y $y \
	-width $wt -height $ht

#
# Create Space-Time View
#

set ST .xpvm.space_time

set ST_L $ST.labels

set ST_C $ST.canvas

set ST_SBH $ST.horiz_sb
set ST_SBV $ST.vert_sb

set st_lwidth [ expr $st_labels_width + $scroll_width ]

set st_cheight [ expr $st_height - $scroll_width \
	- (3 * $row_height) - (7 * $border_space / 2) ]

set st_cwidth [ expr $st_width - $st_lwidth - (2 * $border_space) ]

frame $ST

label $ST.title -text "Space-Time: Tasks vs. Time" \
	-foreground $fg_color

canvas $ST_L -bd $frame_border -relief sunken \
	-scrollincrement 1 -confine 0 \
	-scrollregion "0 0 $st_labels_width $st_canvas_height"

canvas $ST_C -bd $frame_border -relief sunken \
	-scrollincrement 1 -confine 0 \
	-scrollregion "0 0 $scroll_canvas_width $st_canvas_height"

set cmd "scrollViews $ST_C $ST_SBH timex st_cwidth st_xview HORIZ ST 1"

scrollbar $ST_SBH -orient horiz -bd $frame_border -relief sunken \
	-width $scroll_width -command $cmd

scrollInit $ST_C $ST_SBH $st_cwidth $st_cwidth st_xview \
	HORIZ low 1

set cmd "scrollTwoCanvases $ST_L $ST_C $ST_SBV \
	st_canvas_height st_cheight st_yview VERT 1"

scrollbar $ST_SBV -orient vert -bd $frame_border -relief sunken \
	-width $scroll_width -command $cmd

scrollInit $ST_L $ST_SBV $st_canvas_height $st_cheight st_yview \
	VERT low 1

scrollInit $ST_C $ST_SBV $st_canvas_height $st_cheight st_yview \
	VERT low 1

set st_timeline \
	[ $ST_C create line 0 0 0 $st_canvas_height -fill blue ]

label $ST.query -text "View Info:" -bd 2 -relief sunken \
	-foreground $fg_color -anchor nw

button $ST.shrink -bitmap "@$xbm_dir/shrink.xbm" \
	-command "change_st_height shrink" \
	-foreground $fg_color -activeforeground $active_fg_color

button $ST.grow -bitmap "@$xbm_dir/grow.xbm" \
	-command "change_st_height grow" \
	-foreground $fg_color -activeforeground $active_fg_color

set cmd "viewSelect space_time \"Space Time\" \
	views_menu_state_Space_Time TRUE"

button $ST.close -text "Close" -command $cmd \
	-foreground $fg_color -activeforeground $active_fg_color

#
# Create Space-Time Key
#

label $ST.computing_label -text "Computing" \
	-foreground $fg_color

label $ST.computing_box -text "    " \
	-bd 1 -relief sunken -background $st_running_color

label $ST.overhead_label -text "Overhead" \
	-foreground $fg_color

label $ST.overhead_box -text "    " \
	-bd 1 -relief sunken -background $st_system_color

label $ST.waiting_label -text "Waiting" \
	-foreground $fg_color

label $ST.waiting_box -text "    " \
	-bd 1 -relief sunken -background $st_idle_color

label $ST.message_label -text "Message" \
	-foreground $fg_color

label $ST.message_box -text "    " \
	-bd 1 -relief sunken -background $st_comm_color

layout_st_panel

#
# Flush Main XPVM Window Creation
#

update

#
# Create Main Hosts Menu
#

makeMenu .xpvm.hosts_menu do_pvm_hosts [ get_hosts_menu_list ] \
	lower none

#
# Create Other Host Entry
#

entry .xpvm.other -width 40 -font $main_font \
	-bd $frame_border -relief sunken \
	-foreground $fg_color

bind .xpvm.other <Enter> "focus .xpvm.other"
bind .xpvm.other <Return> do_pvm_other_host

place forget .xpvm.other

#
# Create Main Tasks Menu
#

set tasks_info_list \
	[ list \
		[ list "SPAWN"		submenu		.xpvm.spawn	\
			.xpvm.spawn.cmd_entry $spawn_subs ] \
		[ list "KILL"		submenu		.xpvm.kill		none "{}" ] \
		[ list "SIGNAL"		submenu		.xpvm.signal	none "{}" ] \
		[ list "SYS TASKS"	submenu		.xpvm.systasks_menu \
			none "{}" ] \
	]

makeMenu .xpvm.tasks_menu none $tasks_info_list lower none

#
# Create Spawn Dialog Box
#

set spawn_width 300

set SP .xpvm.spawn

frame $SP -bd $frame_border -relief raised

label $SP.cmd -text "Command:" -foreground $fg_color

entry $SP.cmd_entry -font $main_font \
	-bd $frame_border -relief sunken -foreground $fg_color

bind $SP.cmd_entry <Enter> "focus $SP.cmd_entry"
bind $SP.cmd_entry <Return> "focus .xpvm"

label $SP.flags -text "Flags:" -foreground $fg_color

checkbutton $SP.flags_debug -text "PvmTaskDebug" \
	-onvalue ON -offvalue OFF -variable spawn_flags_debug \
	-bd $frame_border -relief flat \
	-selector $selector_color -foreground $fg_color \
	-activeforeground $active_fg_color

checkbutton $SP.flags_trace -text "PvmTaskTrace" \
	-onvalue ON -offvalue OFF -variable spawn_flags_trace \
	-bd $frame_border -relief flat \
	-selector $selector_color -foreground $fg_color \
	-activeforeground $active_fg_color \
	-command layout_spawn_dialog

set cmd "raiseMenu .xpvm.trace_mask_menu $SP.trace_mask .xpvm $tm_subs"

button $SP.trace_mask -text "Trace Mask" -command $cmd \
	-bd $frame_border -relief raised \
	-foreground $fg_color -activeforeground $active_fg_color

checkbutton $SP.flags_front -text "PvmMppFront" \
	-onvalue ON -offvalue OFF -variable spawn_flags_front \
	-bd $frame_border -relief flat \
	-selector $selector_color -foreground $fg_color \
	-activeforeground $active_fg_color

checkbutton $SP.flags_compl -text "PvmHostCompl" \
	-onvalue ON -offvalue OFF -variable spawn_flags_compl \
	-bd $frame_border -relief flat \
	-selector $selector_color -foreground $fg_color \
	-activeforeground $active_fg_color

set spawn_flags_trace ON

label $SP.where -text "Where:" -foreground $fg_color

radiobutton $SP.where_host -text "Host" \
	-command checkSpawnWhere \
	-bd $frame_border -relief flat -value "Host" \
	-variable spawn_where \
	-selector $selector_color -foreground $fg_color \
	-activeforeground $active_fg_color

radiobutton $SP.where_arch -text "Architecture" \
	-command checkSpawnWhere \
	-bd $frame_border -relief flat -value "Arch" \
	-variable spawn_where \
	-selector $selector_color -foreground $fg_color \
	-activeforeground $active_fg_color

radiobutton $SP.where_default -text "Default" \
	-command checkSpawnWhere \
	-bd $frame_border -relief flat -value "Default" \
	-variable spawn_where \
	-selector $selector_color -foreground $fg_color \
	-activeforeground $active_fg_color

set spawn_where Default

set last_spawn_where Default

label $SP.loc -text "Host:" -foreground $fg_color

entry $SP.loc_entry -font $main_font \
	-bd $frame_border -relief sunken -foreground $fg_color

bind $SP.loc_entry <Enter> "focus $SP.loc_entry"
bind $SP.loc_entry <Return> "focus .xpvm"

set spawn_host_string ""
set spawn_arch_string ""

label $SP.ntasks -text "NTasks:" -foreground $fg_color

entry $SP.ntasks_entry -font $main_font \
	-bd $frame_border -relief sunken -foreground $fg_color

bind $SP.ntasks_entry <Enter> "focus $SP.ntasks_entry"
bind $SP.ntasks_entry <Return> "focus .xpvm"

$SP.ntasks_entry insert 0 1

checkbutton $SP.close_on_start -text "Close on Start" \
	-onvalue ON -offvalue OFF -variable spawn_close_on_start \
	-bd $frame_border -relief flat \
	-selector $selector_color -foreground $fg_color \
	-activeforeground $active_fg_color

set spawn_close_on_start "ON"

set cmd "raiseSubMenu .xpvm.spawn .xpvm.tasks_menu \
	.xpvm.tasks_menu.butt_SPAWN .xpvm.spawn.cmd_entry $spawn_subs"

button $SP.close -text "Close" -command $cmd \
	-bd $frame_border -relief raised -foreground $fg_color \
	-activeforeground $active_fg_color

button $SP.start_append -text "Start Append" \
	-bd $frame_border -relief raised -foreground $fg_color \
	-activeforeground $active_fg_color \
	-command "do_spawn append"

button $SP.start -text "Start" \
	-bd $frame_border -relief raised -foreground $fg_color \
	-activeforeground $active_fg_color \
	-command "do_spawn fresh"

layout_spawn_dialog

place forget $SP

#
# Create Kill Dialog Box
#

set kill_height 300
set kill_width 300

set kill_canvas_height 200
set kill_canvas_width 80

set kill_tasklist none

set KL .xpvm.kill

set KL_C $KL.canvas

set KL_SBH $KL.horiz_sb
set KL_SBV $KL.vert_sb

frame $KL -bd $frame_border -relief raised

# Scrolling Task Window

label $KL.tasks -text "Tasks:" -foreground $fg_color

set kill_cheight [ expr $kill_height - $scroll_width \
	- (2 * $row_height) - (3 * $border_space) ]

set kill_cwidth [ expr $kill_width - $scroll_width \
	- (2 * $border_space)]

canvas $KL_C -bd $frame_border -relief sunken \
	-scrollincrement $row_height -confine 0 \
	-scrollregion "0 0 $kill_canvas_height $kill_canvas_width"

set cmd "scrollCanvas $KL_C $KL_SBH \
	kill_canvas_width kill_cwidth kill_xview HORIZ $row_height"

scrollbar $KL_SBH -orient horiz -bd $frame_border -relief sunken \
	-width $scroll_width -command $cmd

scrollInit $KL_C $KL_SBH \
	$kill_canvas_width $kill_cwidth kill_xview HORIZ low $row_height

set cmd "scrollCanvas $KL_C $KL_SBV \
	kill_lasty kill_cheight kill_yview VERT $row_height"

set kill_lasty 0

scrollbar $KL_SBV -orient vert -bd $frame_border -relief sunken \
	-width $scroll_width -command $cmd

scrollInit $KL_C $KL_SBV \
	$kill_lasty $kill_cheight kill_yview VERT low $row_height

# Control Buttons

set cmd "raiseSubMenu .xpvm.kill .xpvm.tasks_menu \
	.xpvm.tasks_menu.butt_KILL none {}"

button $KL.close -text "Close" -command $cmd \
	-bd $frame_border -relief raised -foreground $fg_color \
	-activeforeground $active_fg_color

button $KL.refresh -text "Refresh Tasks" \
	-bd $frame_border -relief raised -foreground $fg_color \
	-activeforeground $active_fg_color \
	-command "do_kill refresh"

button $KL.kill_all -text "Kill All" \
	-bd $frame_border -relief raised -foreground $fg_color \
	-activeforeground $active_fg_color \
	-command "do_kill all"

layout_kill_dialog

place forget $KL

#
# Create Signal Dialog Box
#

set num_signals 31

set signal_height 300
set signal_width 300

set signal_canvas_height 200
set signal_canvas_width 80

set signal_tasklist none

set signal_list_height \
	[ expr ($num_signals * $row_height) + (2 * $frame_border) ]
set signal_list_width [ expr 9 * $col_width ]

set SG .xpvm.signal

frame $SG -bd $frame_border -relief raised

set SG_C $SG.canvas

set SG_SBH $SG.horiz_sb
set SG_SBV $SG.vert_sb

set SG_LF $SG.list_frame
set SG_LC $SG_LF.canvas
set SG_LCW $SG_LC.win

set SG_LSBV $SG.list_vert_sb

# Scrolling Task Window

label $SG.tasks -text "Tasks:" -foreground $fg_color

set signal_cheight [ expr $signal_height - $scroll_width \
	- (2 * $row_height) - (3 * $border_space) ]

set signal_cwidth [ expr $signal_width - (2 * $scroll_width) \
	- $signal_list_width - (3 * $border_space)]

canvas $SG_C -bd $frame_border -relief sunken \
	-scrollincrement $row_height -confine 0 \
	-scrollregion "0 0 $signal_canvas_height $signal_canvas_width"

set signal_win_width [ expr $signal_canvas_width * $col_width ]

set cmd "scrollCanvas $SG_C $SG_SBH \
	signal_win_width signal_cwidth signal_xview HORIZ $row_height"

scrollbar $SG_SBH -orient horiz -bd $frame_border -relief sunken \
	-width $scroll_width -command $cmd

scrollInit $SG_C $SG_SBH \
	$signal_win_width $signal_cwidth signal_xview \
	HORIZ low $row_height 

set cmd "scrollCanvas $SG_C $SG_SBV \
	signal_lasty signal_cheight signal_yview VERT $row_height"

set signal_lasty 0

scrollbar $SG_SBV -orient vert -bd $frame_border -relief sunken \
	-width $scroll_width -command $cmd

scrollInit $SG_C $SG_SBV \
	$signal_lasty $signal_cheight signal_yview VERT low $row_height 

# Scrolling Signal Window

label $SG.signals -text "Signals:" -foreground $fg_color

frame $SG_LF -relief sunken -bd $frame_border

canvas $SG_LC \
	-scrollincrement $row_height -confine 0 \
	-scrollregion "0 0 $signal_canvas_height $num_signals"

frame $SG_LCW

set signal_canvas_list_win \
	[ $SG_LC create window 0 0 -window $SG_LCW -anchor nw \
		-width $signal_list_width -height $signal_list_height ]

signal_button hup		"SIGHUP         "
signal_button int		"SIGINT         "
signal_button quit		"SIGQUIT        "
signal_button ill		"SIGILL         "
signal_button trap		"SIGTRAP        "
signal_button abrt		"SIGABRT        "
signal_button emt		"SIGEMT         "
signal_button fpe		"SIGFPE         "
signal_button kill		"SIGKILL        "
signal_button bus		"SIGBUS         "
signal_button segv		"SIGSEGV        "
signal_button sys		"SIGSYS         "
signal_button pipe		"SIGPIPE        "
signal_button alrm		"SIGALRM        "
signal_button term		"SIGTERM        "
signal_button urg		"SIGURG         "
signal_button stop		"SIGSTOP        "
signal_button tstp		"SIGTSTP        "
signal_button cont		"SIGCONT        "
signal_button chld		"SIGCHLD        "
signal_button ttin		"SIGTTIN        "
signal_button ttou		"SIGTTOU        "
signal_button io		"SIGIO          "
signal_button xcpu		"SIGXCPU        "
signal_button xfsz		"SIGXFSZ        "
signal_button vtalrm	"SIGVTALRM      "
signal_button prof		"SIGPROF        "
signal_button winch		"SIGWINCH       "
signal_button lost		"SIGLOST        "
signal_button usr1		"SIGUSR1        "
signal_button usr2		"SIGUSR2        "

set signal_selected none

set cmd "scrollCanvas $SG_LC $SG_LSBV \
	signal_list_height signal_cheight signal_list_yview \
	VERT $row_height"

scrollbar $SG_LSBV -orient vert -bd $frame_border -relief sunken \
	-width $scroll_width -command $cmd

scrollInit $SG_LC $SG_LSBV \
	$signal_list_height $signal_cheight signal_list_yview \
	VERT low $row_height 

# Control Buttons

set cmd "raiseSubMenu .xpvm.signal .xpvm.tasks_menu \
	.xpvm.tasks_menu.butt_SIGNAL none {}"

button $SG.close -text "Close" -command $cmd \
	-bd $frame_border -relief raised -foreground $fg_color \
	-activeforeground $active_fg_color

button $SG.refresh -text "Refresh Tasks" \
	-bd $frame_border -relief raised -foreground $fg_color \
	-activeforeground $active_fg_color \
	-command "do_signal refresh"

button $SG.signal_all -text "Signal All" \
	-bd $frame_border -relief raised -foreground $fg_color \
	-activeforeground $active_fg_color \
	-command "do_signal all"

layout_signal_dialog

place forget $SG

#
# Create Trace Mask Menus
#

set trace_mask_info_list \
	[ list \
		[ list "ALL EVENTS"		checkbutton	"ALL_EVENTS"	] \
		[ list "Host Events"	exchange	.xpvm.host_ev_menu \
			$SP.trace_mask .xpvm "{}" ] \
		[ list "Group Events"	exchange	.xpvm.group_ev_menu \
			$SP.trace_mask .xpvm "{}" ] \
		[ list "Task Events"	exchange	.xpvm.task_ev_menu \
			$SP.trace_mask .xpvm "{}" ] \
		[ list "Comm Events"	exchange	.xpvm.comm_ev_menu \
			$SP.trace_mask .xpvm "{}" ] \
		[ list "Collect Events"	exchange	.xpvm.coll_ev_menu \
			$SP.trace_mask .xpvm "{}" ] \
		[ list "Buffer Events"	exchange	.xpvm.buff_ev_menu \
			$SP.trace_mask .xpvm "{}" ] \
		[ list "Pack Events"	exchange	.xpvm.pack_ev_menu \
			$SP.trace_mask .xpvm "{}" ] \
		[ list "Unpack Events"	exchange	.xpvm.unpack_ev_menu \
			$SP.trace_mask .xpvm "{}" ] \
		[ list "Info Events"	exchange	.xpvm.info_ev_menu \
			$SP.trace_mask .xpvm "{}" ] \
		[ list "Misc Events"	exchange	.xpvm.misc_ev_menu \
			$SP.trace_mask .xpvm "{}" ] \
	]

makeMenu .xpvm.trace_mask_menu trace_mask $trace_mask_info_list \
	lower trace_mask

### Note, no define_trace_mask for ALL_EVENTS, hard-wired, obvious

set host_ev_info_list \
	[ list \
		[ list "Host Events:"		label	 	none ] \
		[ list "ALL HOST EVENTS"	checkbutton	"ALL_HOST_EVENTS"	] \
		[ list "ADDHOSTS"			checkbutton	"ADDHOSTS"			] \
		[ list "DELHOSTS"			checkbutton	"DELHOSTS"			] \
		[ list "CONFIG"				checkbutton	"CONFIG"			] \
		[ list "MSTAT"				checkbutton	"MSTAT"				] \
		[ list "ARCHCODE"			checkbutton "ARCHCODE"			] \
		[ list "HOSTSYNC"			checkbutton "HOSTSYNC"			] \
	]

define_trace_mask ALL_HOST_EVENTS \
	[ list ADDHOSTS DELHOSTS CONFIG MSTAT ARCHCODE HOSTSYNC ]

set close "exchangeMenu .xpvm.host_ev_menu .xpvm.trace_mask_menu \
	$SP.trace_mask .xpvm $tm_subs"

makeMenu .xpvm.host_ev_menu trace_mask $host_ev_info_list \
	$close trace_mask

set group_ev_info_list \
	[ list \
		[ list "Group Events:"		label	 	none ] \
		[ list "ALL GROUP EVENTS"	checkbutton	"ALL_GROUP_EVENTS"	] \
		[ list "BARRIER"			checkbutton	"BARRIER"			] \
		[ list "BCAST"				checkbutton	"BCAST"				] \
		[ list "DELETE"				checkbutton	"DELETE"			] \
		[ list "GETINST"			checkbutton	"GETINST"			] \
		[ list "GETTID"				checkbutton	"GETTID"			] \
		[ list "GSIZE"				checkbutton	"GSIZE"				] \
		[ list "INSERT"				checkbutton	"INSERT"			] \
		[ list "JOINGROUP"			checkbutton	"JOINGROUP"			] \
		[ list "LOOKUP"				checkbutton	"LOOKUP"			] \
		[ list "LVGROUP"			checkbutton	"LVGROUP"			] \
	]

define_trace_mask ALL_GROUP_EVENTS \
	[ list BARRIER BCAST DELETE GETINST GETTID \
		GSIZE INSERT JOINGROUP LOOKUP LVGROUP ]

set close "exchangeMenu .xpvm.group_ev_menu .xpvm.trace_mask_menu \
	$SP.trace_mask .xpvm $tm_subs"

makeMenu .xpvm.group_ev_menu trace_mask $group_ev_info_list \
	$close trace_mask

set task_ev_info_list \
	[ list \
		[ list "Task Events:"		label	 	none ] \
		[ list "ALL TASK EVENTS"	checkbutton	"ALL_TASK_EVENTS"	] \
		[ list "MYTID"				checkbutton	"MYTID"				] \
		[ list "PARENT"				checkbutton	"PARENT"			] \
		[ list "SPAWN"				checkbutton	"SPAWN"				] \
		[ list "SENDSIG"			checkbutton	"SENDSIG"			] \
		[ list "KILL"				checkbutton	"KILL"				] \
		[ list "EXIT"				checkbutton	"EXIT"				] \
	]

define_trace_mask ALL_TASK_EVENTS \
	[ list MYTID PARENT SPAWN SENDSIG KILL EXIT ]

set close "exchangeMenu .xpvm.task_ev_menu .xpvm.trace_mask_menu \
	$SP.trace_mask .xpvm $tm_subs"

makeMenu .xpvm.task_ev_menu trace_mask $task_ev_info_list \
	$close trace_mask

set comm_ev_info_list \
	[ list \
		[ list "Comm Events:"		label	 	none ] \
		[ list "ALL COMM EVENTS"	checkbutton	"ALL_COMM_EVENTS"	] \
		[ list "MCAST"				checkbutton	"MCAST"				] \
		[ list "SEND"				checkbutton	"SEND"				] \
		[ list "RECV"				checkbutton	"RECV"				] \
		[ list "NRECV"				checkbutton	"NRECV"				] \
		[ list "RECVF"				checkbutton	"RECVF"				] \
		[ list "PSEND"				checkbutton	"PSEND"				] \
		[ list "PRECV"				checkbutton	"PRECV"				] \
		[ list "TRECV"				checkbutton	"TRECV"				] \
		[ list "PROBE"				checkbutton	"PROBE"				] \
	]

define_trace_mask ALL_COMM_EVENTS \
	[ list MCAST SEND RECV NRECV RECVF PSEND PRECV TRECV PROBE ]

set close "exchangeMenu .xpvm.comm_ev_menu .xpvm.trace_mask_menu \
	$SP.trace_mask .xpvm $tm_subs"

makeMenu .xpvm.comm_ev_menu trace_mask $comm_ev_info_list \
	$close trace_mask


set coll_ev_info_list \
	[ list \
		[ list "Collective Events:"		label	 	none ] \
		[ list "ALL COLL EVENTS"	checkbutton	"ALL_COLL_EVENTS"	] \
		[ list "GATHER"				checkbutton	"GATHER"			] \
		[ list "SCATTER"			checkbutton	"SCATTER"			] \
		[ list "REDUCE"				checkbutton	"REDUCE"			] \
	]

define_trace_mask ALL_COLL_EVENTS \
	[ list GATHER SCATTER REDUCE ]

set close "exchangeMenu .xpvm.coll_ev_menu .xpvm.trace_mask_menu \
	$SP.trace_mask .xpvm $tm_subs"

makeMenu .xpvm.coll_ev_menu trace_mask $coll_ev_info_list \
	$close trace_mask

set buff_ev_info_list \
	[ list \
		[ list "Buffer Events:"		label	 	none ] \
		[ list "ALL BUF EVENTS"		checkbutton	"ALL_BUF_EVENTS"	] \
		[ list "INITSEND"			checkbutton	"INITSEND"			] \
		[ list "MKBUF"				checkbutton	"MKBUF"				] \
		[ list "BUFINFO"			checkbutton	"BUFINFO"			] \
		[ list "FREEBUF"			checkbutton	"FREEBUF"			] \
		[ list "GETRBUF"			checkbutton	"GETRBUF"			] \
		[ list "SETRBUF"			checkbutton	"SETRBUF"			] \
		[ list "GETSBUF"			checkbutton	"GETSBUF"			] \
		[ list "SETSBUF"			checkbutton	"SETSBUF"			] \
		[ list "GETMWID"			checkbutton	"GETMWID"			] \
		[ list "SETMWID"			checkbutton	"SETMWID"			] \
	]

define_trace_mask ALL_BUF_EVENTS \
	[ list INITSEND MKBUF BUFINFO FREEBUF \
		GETRBUF SETRBUF GETSBUF SETSBUF GETMWID SETMWID ]

set close "exchangeMenu .xpvm.buff_ev_menu .xpvm.trace_mask_menu \
	$SP.trace_mask .xpvm $tm_subs"

makeMenu .xpvm.buff_ev_menu trace_mask $buff_ev_info_list \
	$close trace_mask

set pack_ev_info_list \
	[ list \
		[ list "Packing Events:"	label	 	none ] \
		[ list "ALL PACK EVENTS"	checkbutton	"ALL_PACK_EVENTS"	] \
		[ list "PKBYTE"				checkbutton	"PKBYTE"			] \
		[ list "PKCPLX"				checkbutton	"PKCPLX"			] \
		[ list "PKDCPLX"			checkbutton	"PKDCPLX"			] \
		[ list "PKDOUBLE"			checkbutton	"PKDOUBLE"			] \
		[ list "PKFLOAT"			checkbutton	"PKFLOAT"			] \
		[ list "PKINT"				checkbutton	"PKINT"				] \
		[ list "PKUINT"				checkbutton	"PKUINT"			] \
		[ list "PKLONG"				checkbutton	"PKLONG"			] \
		[ list "PKULONG"			checkbutton	"PKULONG"			] \
		[ list "PKSHORT"			checkbutton	"PKSHORT"			] \
		[ list "PKUSHORT"			checkbutton	"PKUSHORT"			] \
		[ list "PKSTR"				checkbutton	"PKSTR"				] \
		[ list "PACKF"				checkbutton	"PACKF"				] \
	]

define_trace_mask ALL_PACK_EVENTS \
	[ list PKBYTE PKCPLX PKDCPLX PKDOUBLE PKFLOAT \
		PKINT PKUINT PKLONG PKULONG PKSHORT PKUSHORT PKSTR PACKF ]

set close "exchangeMenu .xpvm.pack_ev_menu .xpvm.trace_mask_menu \
	$SP.trace_mask .xpvm $tm_subs"

makeMenu .xpvm.pack_ev_menu trace_mask $pack_ev_info_list \
	$close trace_mask

set unpack_ev_info_list \
	[ list \
		[ list "Unpacking Events:"	label	 	none ] \
		[ list "ALL UNPACK EVENTS"	checkbutton	"ALL_UNPACK_EVENTS"	] \
		[ list "UPKBYTE"			checkbutton	"UPKBYTE"			] \
		[ list "UPKCPLX"			checkbutton	"UPKCPLX"			] \
		[ list "UPKDCPLX"			checkbutton	"UPKDCPLX"			] \
		[ list "UPKDOUBLE"			checkbutton	"UPKDOUBLE"			] \
		[ list "UPKFLOAT"			checkbutton	"UPKFLOAT"			] \
		[ list "UPKINT"				checkbutton	"UPKINT"			] \
		[ list "UPKUINT"			checkbutton	"UPKUINT"			] \
		[ list "UPKLONG"			checkbutton	"UPKLONG"			] \
		[ list "UPKULONG"			checkbutton	"UPKULONG"			] \
		[ list "UPKSHORT"			checkbutton	"UPKSHORT"			] \
		[ list "UPKUSHORT"			checkbutton	"UPKUSHORT"			] \
		[ list "UPKSTR"				checkbutton	"UPKSTR"			] \
		[ list "UNPACKF"			checkbutton	"UNPACKF"			] \
	]

define_trace_mask ALL_UNPACK_EVENTS \
	[ list UPKBYTE UPKCPLX UPKDCPLX UPKDOUBLE UPKFLOAT \
		UPKINT UPKUINT UPKLONG UPKULONG UPKSHORT UPKUSHORT UPKSTR \
		UNPACKF ]

set close "exchangeMenu .xpvm.unpack_ev_menu .xpvm.trace_mask_menu \
	$SP.trace_mask .xpvm $tm_subs"

makeMenu .xpvm.unpack_ev_menu trace_mask $unpack_ev_info_list \
	$close trace_mask

set info_ev_info_list \
	[ list \
		[ list "Info Events:"		label	 	none ] \
		[ list "ALL INFO EVENTS"	checkbutton	"ALL_INFO_EVENTS"	] \
		[ list "PSTAT"				checkbutton	"PSTAT"				] \
		[ list "TASKS"				checkbutton	"TASKS"				] \
		[ list "GETOPT"				checkbutton	"GETOPT"			] \
		[ list "SETOPT"				checkbutton	"SETOPT"			] \
		[ list "TIDTOHOST"			checkbutton	"TIDTOHOST"			] \
		[ list "GETFDS"				checkbutton	"GETFDS"			] \
	]

define_trace_mask ALL_INFO_EVENTS \
	[ list PSTAT TASKS GETOPT SETOPT TIDTOHOST GETFDS ]

set close "exchangeMenu .xpvm.info_ev_menu .xpvm.trace_mask_menu \
	$SP.trace_mask .xpvm $tm_subs"

makeMenu .xpvm.info_ev_menu trace_mask $info_ev_info_list \
	$close trace_mask

set misc_ev_info_list \
	[ list \
		[ list "Misc Events:"		label	 	none ] \
		[ list "ALL MISC EVENTS"	checkbutton	"ALL_MISC_EVENTS"	] \
		[ list "START PVMD"			checkbutton	"START_PVMD"		] \
		[ list "REG HOSTER"			checkbutton	"REG_HOSTER"		] \
		[ list "REG RM"				checkbutton	"REG_RM"			] \
		[ list "REG TASKER"			checkbutton	"REG_TASKER"		] \
		[ list "CATCHOUT"			checkbutton	"CATCHOUT"			] \
		[ list "NOTIFY"				checkbutton	"NOTIFY"			] \
		[ list "GETTMASK"			checkbutton	"GETTMASK"			] \
		[ list "SETTMASK"			checkbutton	"SETTMASK"			] \
		[ list "PERROR"				checkbutton	"PERROR"			] \
		[ list "TICKLE"				checkbutton	"TICKLE"			] \
		[ list "VERSION"			checkbutton	"VERSION"			] \
		[ list "HALT"				checkbutton	"HALT"				] \
	]

define_trace_mask ALL_MISC_EVENTS \
	[ list START_PVMD REG_HOSTER REG_RM REG_TASKER \
		CATCHOUT NOTIFY GETTMASK SETTMASK PERROR TICKLE VERSION HALT ]

set close "exchangeMenu .xpvm.misc_ev_menu .xpvm.trace_mask_menu \
	$SP.trace_mask .xpvm $tm_subs"

makeMenu .xpvm.misc_ev_menu trace_mask $misc_ev_info_list \
	$close trace_mask

#
# Set Default Trace Mask
#

define_trace_mask DEFAULT \
	[ list BARRIER BCAST DELETE GETINST GETTID \
			GSIZE INSERT JOINGROUP LOOKUP LVGROUP \
		MYTID PARENT SPAWN SENDSIG KILL EXIT \
		SEND RECV RECVF NRECV PSEND PRECV TRECV PROBE MCAST ]

#
# Create System Tasks Menu
#

set systasks_info_list \
	[ list \
		[ list "Group Servers"	checkbutton	 group	] \
	]

makeMenu .xpvm.systasks_menu systasks $systasks_info_list lower none

#
# Create Reset Menu
#

set reset_info_list \
	[ list \
		[ list "Reset PVM"		command	 pvm		] \
		[ list "Reset Views"	command	 views		] \
		[ list "Reset Trace"	command	 trace_file	] \
		[ list "Reset All"		command	 all		] \
	]

makeMenu .xpvm.reset_menu reset $reset_info_list lower none

#
# Create View Selection Menu
#

set view_info_list \
	[ list \
		[ list "Network"		checkbutton	 network		ON	] \
		[ list "Space Time"		checkbutton	 space_time		ON	] \
		[ list "Utilization"	checkbutton	 utilization	OFF	] \
		[ list "Call Trace"		checkbutton	 call_trace		OFF	] \
		[ list "Task Output"	checkbutton	 task_output	OFF	] \
	]

makeMenu .xpvm.views_menu viewSelect $view_info_list lower none

#
# Create Help Menus
#

set help_info_list \
	[ list \
		[ list "General Help:"	label	 none ] \
		[ list "About XPVM"		command	 xpvm ] \
		[ list "Hosts"			command	 hosts ] \
		[ list "Tasks"			exchange	 .xpvm.tasks_help_menu \
			.xpvm.help .xpvm "{}" ] \
		[ list "Reset"			command	 reset ] \
		[ list "Quit"			command	 quit ] \
		[ list "Halt"			command	 halt ] \
		[ list "Views"			exchange	 .xpvm.views_help_menu \
			.xpvm.help .xpvm "{}" ] \
		[ list "Traces"			command	 traces ] \
		[ list "Author"			command	 author ] \
	]

makeMenu .xpvm.help_menu helpSelect $help_info_list lower none

set tasks_help_info_list \
	[ list \
		[ list "Task Help:"	label	 none ] \
		[ list "Spawn"		command	 tasks_spawn ] \
		[ list "Kill"		command	 tasks_kill ] \
		[ list "Signal"		command	 tasks_signal ] \
		[ list "Sys Tasks"	command	 tasks_systasks ] \
	]

set close "exchangeMenu .xpvm.tasks_help_menu .xpvm.help_menu \
	.xpvm.help .xpvm {}"

makeMenu .xpvm.tasks_help_menu helpSelect $tasks_help_info_list \
	$close none

set views_help_info_list \
	[ list \
		[ list "Views Help:"	label	 none ] \
		[ list "Network"		command	 views_network ] \
		[ list "Space Time"		command	 views_space_time ] \
		[ list "Utilization"	command	 views_utilization ] \
		[ list "Call Trace"		command	 views_call_trace ] \
		[ list "Task Output"	command	 views_task_output ] \
	]

set close "exchangeMenu .xpvm.views_help_menu .xpvm.help_menu \
	.xpvm.help .xpvm {}"

makeMenu .xpvm.views_help_menu helpSelect $views_help_info_list \
	$close none

#
# Create Trace Overwrite Check Dialog Box
#

set OV .xpvm.overwrite

frame $OV -bd 4 -relief raised

label $OV.label -text "Overwrite Trace File:" -foreground $fg_color

label $OV.file -text "Dummy File" -foreground $fg_color

button $OV.yes -text "Yes" \
	-command "place forget $OV ; trace_overwrite_result TRUE" \
	-bd $frame_border -relief raised -foreground $fg_color \
	-activeforeground $active_fg_color

button $OV.no -text "No" \
	-command "place forget $OV ; trace_overwrite_result FALSE" \
	-bd $frame_border -relief raised -foreground $fg_color \
	-activeforeground $active_fg_color

set y $border_space

place $OV.label -relx 0.50 -y $y -anchor n

set y [ expr $y + $row_height + $border_space ]

place $OV.file -relx 0.50 -y $y -anchor n

set y [ expr $y + $row_height + $border_space ]

place $OV.yes -relx 0.35 -y $y -anchor n

place $OV.no -relx 0.65 -y $y -anchor n

place forget $OV

#
# Flush Main Menus / Dialogs Creation
#

update

#
# Create Toplevel for Utilization
#

set ut_geom "[ expr $ut_width ]x[ expr $ut_height ]"

toplevel .utilization

wm geometry .utilization $ut_geom

set min_ut_height [ expr (4 * $row_height) + $scroll_width \
	+ (5 * $border_space / 2) + 20 ]

set min_ut_width 350

wm minsize .utilization $min_ut_width $min_ut_height

#
# Withdraw Window - Not Raised Initially
#

wm withdraw .utilization

#
# Create Utilization View
#

set UT_C .utilization.frame.canvas

set UT_SBH .utilization.frame.horiz_sb

set ut_cheight [ expr $ut_height - $scroll_width \
	- $row_height - (5 * $border_space) ]

set ut_cwidth [ expr $ut_width \
	- (3 * $col_width) - (2 * $border_space) ]

frame .utilization.frame

label .utilization.frame.title -text "Utilization vs. Time" \
	-foreground $fg_color

label .utilization.frame.xN -text "N" -foreground $fg_color
label .utilization.frame.xT -text "T" -foreground $fg_color
label .utilization.frame.xA -text "A" -foreground $fg_color
label .utilization.frame.xS -text "S" -foreground $fg_color
label .utilization.frame.xK -text "K" -foreground $fg_color
label .utilization.frame.xX -text "S" -foreground $fg_color

label .utilization.frame.ntasks -text $ut_max_ntasks \
	-foreground $fg_color

label .utilization.frame.tick -text "    " \
	-background $fg_color

label .utilization.frame.zero -text "0" \
	-foreground $fg_color

canvas $UT_C -bd $frame_border -relief sunken \
	-scrollincrement 1 -confine 0 \
	-scrollregion "0 0 $scroll_canvas_width $ut_canvas_height"

set cmd "scrollViews $UT_C $UT_SBH timex ut_cwidth ut_xview HORIZ UT 1"

scrollbar $UT_SBH -orient horiz -bd $frame_border -relief sunken \
	-width $scroll_width -command $cmd

scrollInit $UT_C $UT_SBH $ut_cwidth $ut_cwidth ut_xview HORIZ low 1

set cmd "viewSelect utilization Utilization \
	views_menu_state_Utilization TRUE"

button .utilization.frame.close -text "Close" -command $cmd \
	-foreground $fg_color -activeforeground $active_fg_color

#
# Create Utilization Key
#

label .utilization.frame.computing_label -text "Computing" \
	-foreground $fg_color

label .utilization.frame.computing_box -text "    " \
	-bd 1 -relief sunken -background $ut_running_color

label .utilization.frame.overhead_label -text "Overhead" \
	-foreground $fg_color

label .utilization.frame.overhead_box -text "    " \
	-bd 1 -relief sunken -background $ut_system_color

label .utilization.frame.waiting_label -text "Waiting" \
	-foreground $fg_color

label .utilization.frame.waiting_box -text "    " \
	-bd 1 -relief sunken -background $ut_idle_color

layout_ut_panel

#
# Create Call Trace Toplevel
#

set ct_geom "[ expr $ct_width ]x[ expr $ct_height ]"

toplevel .call_trace

wm geometry .call_trace $ct_geom

set min_ct_height [ expr (3 * $scroll_width) + $row_height \
	+ (3 * $border_space) ]

set min_ct_width [ expr $ct_labels_width + (3 * $scroll_width) \
	+ (2 * $border_space) ]

wm minsize .call_trace $min_ct_width $min_ct_height

#
# Withdraw Window - Not Raised Initially
#

wm withdraw .call_trace

#
# Create Call Trace View
#

set CT_L .call_trace.frame.labels

set CT_C .call_trace.frame.canvas

set CT_SBH .call_trace.frame.horiz_sb
set CT_SBV .call_trace.frame.vert_sb

set ct_lwidth [ expr $ct_labels_width + $scroll_width ]

set ct_cheight [ expr $ct_height - $scroll_width \
	- $row_height - (3 * $border_space) ]

set ct_cwidth [ expr $ct_width - $ct_lwidth - (2 * $border_space) ]

frame .call_trace.frame

label .call_trace.frame.title -text "Last Event Per Task:" \
	-foreground $fg_color

label .call_trace.frame.query -text "" -foreground $fg_color

canvas $CT_L -bd $frame_border -relief sunken \
	-scrollincrement 1 -confine 0 \
	-scrollregion "0 0 $ct_labels_width $ct_canvas_height"

canvas $CT_C -bd $frame_border -relief sunken \
	-scrollincrement 1 -confine 0 \
	-scrollregion "0 0 $ct_canvas_width $ct_canvas_height"

set cmd "scrollCanvas $CT_C $CT_SBH \
	ct_canvas_width ct_cwidth ct_xview HORIZ 1"

scrollbar $CT_SBH -orient horiz -bd $frame_border -relief sunken \
	-width $scroll_width -command $cmd

scrollInit $CT_C $CT_SBH $ct_canvas_width $ct_cwidth ct_xview \
	HORIZ low 1

set cmd "scrollTwoCanvases $CT_L $CT_C $CT_SBV \
	ct_canvas_height ct_cheight ct_yview VERT 1"

scrollbar $CT_SBV -orient vert -bd $frame_border -relief sunken \
	-width $scroll_width -command $cmd

scrollInit $CT_L $CT_SBV $ct_canvas_height $ct_cheight ct_yview \
	VERT low 1

scrollInit $CT_C $CT_SBV $ct_canvas_height $ct_cheight ct_yview \
	VERT low 1

set cmd "viewSelect call_trace \"Call Trace\" \
	views_menu_state_Call_Trace TRUE"

button .call_trace.frame.close -text "Close" -command $cmd \
	-foreground $fg_color -activeforeground $active_fg_color

layout_ct_panel

#
# Create Task Output Toplevel
#

set TO .task_output

set to_geom "[ expr $to_width ]x[ expr $to_height ]"

toplevel $TO

wm geometry $TO $to_geom

set min_to_height [ expr (3 * $scroll_width) + $row_height \
	+ (3 * $border_space) ]

set min_to_width [ expr (3 * $scroll_width) + (2 * $border_space) ]

wm minsize $TO $min_to_width $min_to_height

set to_saveout ""

#
# Withdraw Window - Not Raised Initially
#

wm withdraw $TO

#
# Create Task Output View
#

set TO_C $TO.frame.canvas

set TO_SBH $TO.frame.horiz_sb
set TO_SBV $TO.frame.vert_sb

set to_cheight [ expr $to_height - $scroll_width \
	- $row_height - (5 * $border_space) ]

set to_cwidth [ expr $to_width - $scroll_width - (2 * $border_space) ]

set to_lasty $frame_border

set to_list [ list "" ]

set to_numout 0

frame $TO.frame

label $TO.frame.title -text "Task Output:" \
	-foreground $fg_color

entry $TO.file_entry -font $main_font \
	-bd $frame_border -relief sunken -foreground $fg_color

bind $TO.file_entry <Enter> "focus $TO.file_entry"
bind $TO.file_entry <Leave> "set_output_file"
bind $TO.file_entry <Return> "set_output_file"

set output_file ""

canvas $TO_C -bd $frame_border -relief sunken \
	-scrollincrement $row_height -confine 0 \
	-scrollregion "0 0 $to_canvas_width $to_canvas_height"

set cmd "scrollCanvas $TO_C $TO_SBH \
	to_canvas_width to_cwidth to_xview HORIZ $row_height"

scrollbar $TO_SBH -orient horiz -bd $frame_border -relief sunken \
	-width $scroll_width -command $cmd

scrollInit $TO_C $TO_SBH $to_canvas_width $to_cwidth to_xview \
	HORIZ low $row_height

set cmd "scrollCanvas $TO_C $TO_SBV to_lasty to_cheight to_yview \
	VERT $row_height"

scrollbar $TO_SBV -orient vert -bd $frame_border -relief sunken \
	-width $scroll_width -command $cmd

scrollInit $TO_C $TO_SBV $to_lasty $to_cheight to_yview \
	VERT low $row_height

set cmd "viewSelect task_output \"Task Output\" \
	views_menu_state_Task_Output TRUE"

button $TO.frame.close -text "Close" -command $cmd \
	-foreground $fg_color -activeforeground $active_fg_color

layout_to_panel

#
# Add Canvas Event Handle Bindings
#

bind .xpvm.kill <Map>			"do_kill refresh"
bind .xpvm.kill.canvas <1>		"do_kill %y"

bind .xpvm.signal <Map>			"do_signal refresh"
bind .xpvm.signal.canvas <1>	"do_signal %y"

bind $NET_C <1>					"network %x %y"

bind $ST_L <ButtonPress-1>		"canvas_handle ST label_press %x %y"
bind $ST_L <Button1-Motion>		"canvas_handle ST label_motion %x %y"
bind $ST_L <ButtonRelease-1>	"canvas_handle ST label_release %x %y"

bind $ST_C <ButtonPress-1>		"canvas_handle ST query_press %x %y"
bind $ST_C <Button1-Motion>		"canvas_handle ST query_motion %x %y"
bind $ST_C <ButtonRelease-1>	"canvas_handle ST query_release %x %y"

bind $ST_C <Enter>				"canvas_handle ST enter %x %y"
bind $ST_C <Motion>				"canvas_handle ST time %x %y"
bind $ST_C <Leave>				"canvas_handle ST leave %x %y"

bind $ST_C <ButtonPress-2>		"canvas_handle ST zoom_press %x %y"
bind $ST_C <Button2-Motion>		"canvas_handle ST zoom_motion %x %y"
bind $ST_C <ButtonRelease-2>	"canvas_handle ST zoom_release %x %y"

bind $ST_C <3>					"canvas_handle ST unzoom %x %y"

bind $UT_C <1>					"canvas_handle UT query %x %y"

bind $UT_C <Enter>				"canvas_handle UT enter %x %y"
bind $UT_C <Motion>				"canvas_handle UT time %x %y"
bind $UT_C <Leave>				"canvas_handle UT leave %x %y"

bind $UT_C <ButtonPress-2>		"canvas_handle UT zoom_press %x %y"
bind $UT_C <Button2-Motion>		"canvas_handle UT zoom_motion %x %y"
bind $UT_C <ButtonRelease-2>	"canvas_handle UT zoom_release %x %y"

bind $UT_C <3>					"canvas_handle UT unzoom %x %y"

bind $CT_L <ButtonPress-1>		"ct_canvas_handle label_press %x %y"
bind $CT_L <Button1-Motion>		"ct_canvas_handle label_motion %x %y"
bind $CT_L <ButtonRelease-1>	"ct_canvas_handle label_release %x %y"

bind $CT_C <ButtonPress-1>		"ct_canvas_handle query_press %x %y"
bind $CT_C <Button1-Motion>		"ct_canvas_handle query_motion %x %y"
bind $CT_C <ButtonRelease-1>	"ct_canvas_handle query_release %x %y"

set ADJ .xpvm.controls.adjust

bind $ADJ <ButtonPress-1>		"adjust_main_panel press %y"
bind $ADJ <Button1-Motion>		"adjust_main_panel motion %y"
bind $ADJ <ButtonRelease-1>		"adjust_main_panel release %y"

bind .xpvm <Configure>			"resize_main_panel"

bind .utilization <Configure>	"resize_ut_panel"

bind .call_trace <Configure>	"resize_ct_panel"

bind .task_output <Configure>	"resize_to_panel"

set win_map_list ""

bind .xpvm <Unmap>				"unmap_all"

bind .xpvm <Map>				"remap_all"
bind .utilization <Map>			"remap_all"
bind .call_trace <Map>			"remap_all"
bind .task_output <Map>			"remap_all"

bind .xpvm <Destroy>			"exit"
bind .utilization <Destroy>		"exit"
bind .call_trace <Destroy>		"exit"
bind .task_output <Destroy>		"exit"

#
# Actually Bring Up Main XPVM Window
#

wm deiconify .xpvm

#
# Initialize Trace Status
#

handleTraceFileStatus

trace_file_handle $trace_file

trace_fwd

#
# Reset Welcome Message
#

setMsg "Welcome to XPVM"

update

